.span	

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmCreate : Handles WM_CREATE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmCreate proc hWnd:HWND, cp:dword
	local	rect:RECT
	invoke	GetClientRect, hWnd, addr rect
	
	m2m		hFont, func(CreateFontIndirect, addr lgfont)	
	invoke	CreateWindowEx,\
			WS_EX_CLIENTEDGE, \
			addr szListbox,\
			NULL,\
           	WS_VSCROLL or WS_VISIBLE or WS_BORDER or WS_DISABLED or WS_CHILD or LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or LBS_WANTKEYBOARDINPUT,\
           	rect.left,\
           	rect.top,\
           	rect.right,\
           	rect.bottom,\
           	hWnd,\
           	NULL,\
           	hInstance,\
           	NULL
    mov		lstBox, eax
    
    invoke	SendMessage, lstBox, WM_SETFONT, hFont, 0
    invoke	SendMessage, lstBox, WM_SETFOCUS, 0, 0
    mov		wndlbox, func(SetWindowLong, lstBox, GWL_WNDPROC, addr LstWndProc)
    
	jmp		@f
	WM_CREATE_Format db "WM_CREATE { Class = '%s', hInstance = %08X, x = %i, y = %i, width = %i, height = %i }", 0
	@@:
	
	push	ebx
	mov		ebx, cp
	assume	ebx: ptr CREATESTRUCT

	push	[ebx].ly
	push	[ebx].lx
	push	[ebx].y	
	push	[ebx].x
	push	[ebx].hInstance
	push	[ebx].lpszClass	
	push	offset WM_CREATE_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	assume	ebx: nothing
	pop		ebx	    
	ret
WmCreate endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmCommand : Handles WM_COMMAND message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmCommand proc hWnd:HWND, id:dword, hwndCtl:HWND, codeNotify:dword
	; ----------------------------------------------
	.if id==mnuFileExit
		invoke	PostQuitMessage, 0
	; ----------------------------------------------
	.elseif id==mnuHelpAbout

		invoke	MessageBox, hWnd, addr szHelp, addr szTitle, MB_ICONINFORMATION
		invoke	SendMessage, lstBox, WM_SETFOCUS, 0, 0

	; ----------------------------------------------
	.endif
	
	jmp		@f
	WM_COMMAND_Format db "WM_COMMAND { id = %08X, control = %08X, CodeNotify = %08X }", 0
	@@:
	
	push	codeNotify
	push	hwndCtl
	push	id
	push	offset WM_COMMAND_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmCommand endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmSize : Handles WM_SIZE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmSize proc hWnd:HWND, state:dword, lx:dword, cy:dword
	local	rect:RECT
	
	invoke	GetClientRect, hWnd, addr rect	
	invoke	MoveWindow, lstBox, 0, 0, rect.right, rect.bottom, 1
	
	jmp		@f
	WM_SIZE_Format 	db "WM_SIZE { state = %s, width = %i, height = %i }", 0
	WM_SIZE_state0		db "SIZE_MAXHIDE", 0
	WM_SIZE_state1		db "SIZE_MAXIMIZED", 0
	WM_SIZE_state2		db "SIZE_MAXSHOW", 0
	WM_SIZE_state3		db "SIZE_MINIMIZED", 0
	WM_SIZE_state4		db "SIZE_RESTORED", 0
	@@:
	
	push	cy
	push	lx
	mov		eax, state
	.if eax==SIZE_MAXHIDE
	push	offset WM_SIZE_state0
	.elseif eax==SIZE_MAXIMIZED
	push	offset WM_SIZE_state1
	.elseif eax==SIZE_MAXSHOW
	push	offset WM_SIZE_state2
	.elseif eax==SIZE_MINIMIZED
	push	offset WM_SIZE_state3
	.elseif eax==SIZE_RESTORED
	push	offset WM_SIZE_state4
	.endif
	push	offset WM_SIZE_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0	
	
	ret
WmSize endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmSizing : Handles WM_SIZING message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmSizing proc hWnd:HWND, edge:dword, lpRect:dword
	push	ebx

	jmp		@f
	WM_SIZING_Format 	db "WM_SIZING { edge = %s, x = %i, y = %i, width = %i, height = %i }", 0
	WM_SIZING_edge0		db "WMSZ_BOTTOM", 0
	WM_SIZING_edge1		db "WMSZ_BOTTOMLEFT", 0
	WM_SIZING_edge2		db "WMSZ_BOTTOMRIGHT", 0
	WM_SIZING_edge3		db "WMSZ_LEFT", 0
	WM_SIZING_edge4		db "WMSZ_RIGHT", 0
	WM_SIZING_edge5		db "WMSZ_TOP", 0
	WM_SIZING_edge6		db "WMSZ_TOPLEFT", 0
	WM_SIZING_edge7		db "WMSZ_TOPRIGHT", 0	
	@@:
	
	mov		ebx, lpRect
	assume	ebx: ptr RECT
	
	mov		eax, [ebx].bottom
	sub		eax, [ebx].top
	push	eax
	mov		eax, [ebx].right
	sub		eax, [ebx].left
	push	eax
	push	[ebx].top
	push	[ebx].left
	
	mov		eax, edge
	.if eax==WMSZ_BOTTOM
	push	offset WM_SIZING_edge0
	.elseif eax==WMSZ_BOTTOMLEFT
	push	offset WM_SIZING_edge1
	.elseif eax==WMSZ_BOTTOMRIGHT
	push	offset WM_SIZING_edge2
	.elseif eax==WMSZ_LEFT
	push	offset WM_SIZING_edge3
	.elseif eax==WMSZ_RIGHT
	push	offset WM_SIZING_edge4
	.elseif eax==WMSZ_TOP
	push	offset WM_SIZING_edge5
	.elseif eax==WMSZ_TOPLEFT
	push	offset WM_SIZING_edge6
	.elseif eax==WMSZ_TOPRIGHT
	push	offset WM_SIZING_edge7
	.endif
	
	push	offset WM_SIZING_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0

	assume	ebx: nothing
	pop		ebx
	
	ret
WmSizing endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMouseMove : Handles WM_MOUSEMOVE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmMouseMove proc hWnd:HWND, x:dword, y:dword, keyFlags:dword

	invoke	SetTimer, hWnd, WM_MOUSELEAVE, 20, addr TrackMouseLeaveTimerProc
	
	jmp		@f
	WM_MOUSEMOVE_Format db "WM_MOUSEMOVE { x = %i, y = %i, keyflags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_MOUSEMOVE_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmMouseMove endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMouseLeave : Handles WM_MOUSELEAVE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmMouseLeave proc hWnd:HWND

	jmp		@f
	WM_MOUSELEAVE_msg db "WM_MOUSELEAVE", 0
	@@:
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr WM_MOUSELEAVE_msg
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmMouseLeave endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmNcMouseMove : Handles WM_NCMOUSEMOVE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmNcMouseMove proc hWnd:HWND, x:dword, y:dword, codeHitTest:dword

	invoke	SetTimer, hWnd, WM_NCMOUSEMOVE, 20, addr TrackNcMouseLeaveTimerProc
	
	jmp		@f
	WM_NCMOUSEMOVE_Format db "WM_NCMOUSEMOVE { x = %i, y = %i, HitTestCode = %08X }", 0
	@@:
	
	push	codeHitTest
	push	y
	push	x
	push	offset WM_NCMOUSEMOVE_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmNcMouseMove endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMouseLeave : Handles WM_NCMOUSELEAVE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmNcMouseLeave proc hWnd:HWND

	jmp		@f
	WM_NCMOUSELEAVE_msg db "WM_NCMOUSELEAVE", 0
	@@:
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr WM_NCMOUSELEAVE_msg
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmNcMouseLeave endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMoving : Handles WM_MOVING message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmMoving proc hWnd:HWND, lpRect:dword
	
	push	ebx
	jmp		@f
	WM_MOVING_Format db "WM_MOVING { x = %i, y = %i, width = %i, height = %i }", 0
	@@:
	
	mov		ebx, lpRect
	assume	ebx: ptr RECT
	
	mov		eax, [ebx].bottom
	sub		eax, [ebx].top
	push	eax
	mov		eax, [ebx].right
	sub		eax, [ebx].left
	push	eax
	push	[ebx].top
	push	[ebx].left
	push	offset WM_MOVING_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	pop		ebx
	ret
WmMoving endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMove : Handles WM_MOVE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmMove proc hWnd:HWND, x:dword, y:dword
	
	jmp		@f
	WM_MOVE_Format db "WM_MOVE { x = %i, y = %i }", 0
	@@:
	
	push	y
	push	x
	push	offset WM_MOVE_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmMove endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmLButtonDown : Handles WM_LBUTTONDOWN message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmLButtonDown proc hWnd:HWND, fDoubleClick:BOOL, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_LBUTTONDOWN_Format db "WM_LBUTTONDOWN { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_LBUTTONDOWN_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmLButtonDown endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMButtonDown : Handles WM_MBUTTONDOWN message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmMButtonDown proc hWnd:HWND, fDoubleClick:BOOL, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_MBUTTONDOWN_Format db "WM_MBUTTONDOWN { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_MBUTTONDOWN_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmMButtonDown endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmRButtonDown : Handles WM_RBUTTONDOWN message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmRButtonDown proc hWnd:HWND, fDoubleClick:BOOL, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_RBUTTONDOWN_Format db "WM_RBUTTONDOWN { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_RBUTTONDOWN_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmRButtonDown endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmXButtonDown : Handles WM_XBUTTONDOWN message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmXButtonDown proc hWnd:HWND, fDoubleClick:BOOL, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_XBUTTONDOWN_Format db "WM_XBUTTONDOWN { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_XBUTTONDOWN_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmXButtonDown endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmLButtonUp : Handles WM_LBUTTONUP message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmLButtonUp proc hWnd:HWND, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_LBUTTONUP_Format db "WM_LBUTTONUP { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_LBUTTONUP_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmLButtonUp endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMButtonUp : Handles WM_MBUTTONUP message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmMButtonUp proc hWnd:HWND, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_MBUTTONUP_Format db "WM_MBUTTONUP { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_MBUTTONUP_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmMButtonUp endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmRButtonUp : Handles WM_RBUTTONUP message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmRButtonUp proc hWnd:HWND, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_RBUTTONUP_Format db "WM_RBUTTONUP { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_RBUTTONUP_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmRButtonUp endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmXButtonUp : Handles WM_XBUTTONUP message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmXButtonUp proc hWnd:HWND, x:dword, y:dword, keyFlags:dword

	jmp		@f
	WM_XBUTTONUP_Format db "WM_XBUTTONUP { x = %i, y = %i, KeyFlags = %08X }", 0
	@@:
	
	push	keyFlags
	push	y
	push	x
	push	offset WM_XBUTTONUP_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmXButtonUp endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmMouseWheel : Handles WM_MOUSEWHEEL message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmMouseWheel proc hWnd:HWND, xPos:dword, yPos:dword, zDelta:dword, fwKeys:dword

	jmp		@f
	WM_MOUSEWHEEL_Format db "WM_MOUSEWHEEL { xPos = %i, yPos = %i, Delta = %08X, Keys = %08X }", 0
	@@:
	
	push	fwKeys
	push	zDelta
	push	yPos
	push	xPos
	push	offset WM_MOUSEWHEEL_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmMouseWheel endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; WmKey : Handles WM_CHAR, WM_KEYUP and WM_KEYDOWN messages
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
WmKey proc hWnd:HWND, vk:dword, fDown:BOOL, cRepeat:dword, flags:dword

	jmp		@f
	WM_KEYDOWN_Format db "WM_KEYDOWN { VK = %04X, RepeatCount = %i, Flags = %08X }", 0
	WM_KEYUP_Format db "WM_KEYUP { VK = %04X, RepeatCount = %i, Flags = %08X }", 0
	@@:
	
	push	flags
	push	cRepeat
	push	vk
	.if fDown
	push	offset WM_KEYDOWN_Format
	.else
	push	offset WM_KEYUP_Format
	.endif
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmKey endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmSysKey : Handles WM_SYSKEYUP and WM_SYSKEYDOWN messages
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmSysKey proc hWnd:HWND, vk:dword, fDown:dword, cRepeat:dword, flags:dword

	jmp		@f
	WM_SYSKEYDOWN_Format db "WM_SYSKEYDOWN { VK = %04X, RepeatCount = %i, Flags = %08X }", 0
	WM_SYSKEYUP_Format db "WM_SYSKEYUP { VK = %04X, RepeatCount = %i, Flags = %08X }", 0
	@@:
	
	push	flags
	push	cRepeat
	push	vk
	.if fDown
	push	offset WM_SYSKEYDOWN_Format
	.else
	push	offset WM_SYSKEYUP_Format
	.endif
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0
	
	ret
WmSysKey endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WmActivate : Handles WM_ACTIVATE message
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WmActivate proc hWnd:HWND, state:dword, hWndActDeact:HWND, fMinimized:dword

	jmp		@f
	WM_ACTIVATE_Format 		db "WM_ACTIVATE { state = %s, window = %i, minimized = %s }", 0
	WM_ACTIVATE_state0		db "WA_ACTIVE", 0
	WM_ACTIVATE_state1		db "WA_CLICKACTIVE", 0
	WM_ACTIVATE_state2		db "WA_INACTIVE", 0
	WM_ACTIVATE_true		db "TRUE", 0
	WM_ACTIVATE_false		db "FALSE", 0
	@@:
	
	.if fMinimized
	push	offset WM_ACTIVATE_true
	.else
	push	offset WM_ACTIVATE_false
	.endif
	push	hWndActDeact
	mov		eax, state
	.if eax==WA_ACTIVE
	push	offset WM_ACTIVATE_state0
	.elseif eax==WA_CLICKACTIVE
	push	offset WM_ACTIVATE_state1
	.elseif eax==WA_INACTIVE
	push	offset WM_ACTIVATE_state2
	.endif
	push	offset WM_ACTIVATE_Format
	push	offset buffer
	call	wsprintf
	
	invoke	SendMessage, lstBox, LB_ADDSTRING, 0, addr buffer
	invoke	SendMessage, lstBox, LB_GETCOUNT, 0, 0
	dec		eax
	invoke	SendMessage, lstBox, LB_SETCARETINDEX , eax, 0	
	
	ret
WmActivate endp